It seems that coding tests are conducted overseas in interviews with engineers, and in many cases, the main thing is to implement specific functions and classes according to the theme.
Apparently, many engineers take measures on the site called LetCode.
It is a site that trains the algorithmic power that can withstand the coding test that is being done in the early story, and it is an inevitable path for those who want to build a career at an overseas tech company.
I wrote it in a big way, but I have no plans to have such an interview at the moment.
However, as an IT engineer, it would be better to have the same level of algorithm power as a person, so I would like to solve the problem irregularly and write down the method I thought at that time as a memo.
I'm solving it with Python3.
Leet Code Table of Contents Starting from Zero
Last time Leet Code Day71 "1496. Path Crossing" starting from zero
Right now, I'm prioritizing the Medium of the Top 100 Liked Questions. I solved all Easy, so if you are interested, please go to the table of contents.
Twitter I'm doing it.
** Technical Blog Started! !! ** ** I think the technology will write about LetCode, Django, Nuxt, and so on. ** This is faster to update **, so please bookmark it!
1498. Number of Subsequences That Satisfy the Given Sum Condition The difficulty level is Medium.
The problem is given an array of integers nums
and an integer target
.
Returns the number of non-empty subsequences such that the sum of the minimum and maximum values of nums is less than or equal to the target value.
The answer may be too large, so it returns the modulo 10 ^ 9 + 7.
Example 1:
Input: nums = [3,5,6,7], target = 9 Output: 4 Explanation: There are 4 subsequences that satisfy the condition. [3] -> Min value + max value <= target (3 + 3 <= 9) [3,5] -> (3 + 5 <= 9) [3,5,6] -> (3 + 6 <= 9) [3,6] -> (3 + 6 <= 9)
Example 2:
Input: nums = [3,3,6,8], target = 10 Output: 6 Explanation: There are 6 subsequences that satisfy the condition. (nums can have repeated numbers). [3] , [3] , [3,3], [3,6] , [3,6] , [3,3,6]
Example 3:
Input: nums = [2,3,3,4,6,7], target = 12 Output: 61 Explanation: There are 63 non-empty subsequences, two of them don't satisfy the condition ([6,7], [7]). Number of valid subsequences (63 - 2 = 61).
Example 4:
Input: nums = [5,2,4,1,7,6,8], target = 16 Output: 127 Explanation: All non-empty subset satisfy the condition (2^7 - 1) = 127
Constraints:
- 1 <= nums.length <= 10^5
class Solution:
def numSubseq(self, nums: List[int], target: int) -> int:
ans,mod = 0,10**9+7
nums.sort()
for i,j in enumerate(nums):
if target < j*2:
break
b = bisect.bisect(nums,target-j,lo=i)
ans += pow(2, b-i-1, mod)
return ans % mod
# Runtime: 888 ms, faster than 82.84% of Python3 online submissions for Number of Subsequences That Satisfy the Given Sum Condition.
# Memory Usage: 25.2 MB, less than 100.00% of Python3 online submissions for Number of Subsequences That Satisfy the Given Sum Condition.
As specified in the problem statement, I wrote that mod (10 ** 9 + 7)
is specified first and a binary search is performed in the for statement.
The arguments of bisect are as follows.
bisect(a,b,(lo,hi))
a:list
b:Value to insert
lo:Lower limit of search range
hi:Upper limit of search range
As many of you who read this article know, the list is sorted at the beginning of the code because it is a prerequisite that the binary search is sorted. As far as the example is seen, it seems that there are many cases where it is not sorted ...
By the way, 10 ** 9 + 7 comes out quite a lot when doing other competitive programming (not limited to one because there are many sites). Some people have written easy-to-understand explanation articles about it, so if you are interested, please do that too.
So that's it for this time. Thank you for your hard work.
Recommended Posts